// ServerShutdown.cpp : Defines the class behaviors for the application.
//

#include "JetByteTools/Admin/Admin.h"

#include "stdafx.h"
#include "ServerShutdown.h"
#include "ServerShutdownDlg.h"

#include "JetByteTools/CoreTools/ManualResetEvent.h"
#include "JetByteTools/Win32Tools/GlobalName.h"
#include "JetByteTools/CoreTools/Exception.h"
#include "JetByteTools/Win32Tools/SmartLocalPointer.h"
#include "JetByteTools/CoreTools/StringConverter.h"

#include <string>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using JetByteTools::Core::CManualResetEvent;
using JetByteTools::Win32::CGlobalName;
using JetByteTools::Win32::CSecurityDescriptorAllowAll;
using JetByteTools::Win32::CSecurityAttributes;
using JetByteTools::Win32::CSmartLocalPointer;
using JetByteTools::Core::CStringConverter;
using JetByteTools::Core::_tstring;

using std::wstring;

/////////////////////////////////////////////////////////////////////////////
// CServerShutdownApp

BEGIN_MESSAGE_MAP(CServerShutdownApp, CWinApp)
   //{{AFX_MSG_MAP(CServerShutdownApp)
      // NOTE - the ClassWizard will add and remove mapping macros here.
      //    DO NOT EDIT what you see in these blocks of generated code!
   //}}AFX_MSG
   ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerShutdownApp construction

CServerShutdownApp::CServerShutdownApp()
{
   // TODO: add construction code here,
   // Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CServerShutdownApp object

CServerShutdownApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CServerShutdownApp initialization

BOOL CServerShutdownApp::InitInstance()
{
   // Standard initialization
   // If you are not using these features and wish to reduce the size
   //  of your final executable, you should remove from the following
   //  the specific initialization routines you do not need.

#if (_MSC_VER < 1300)         // Need this for anything earlier than VS2005
#ifdef _AFXDLL
   Enable3dControls();         // Call this when using MFC in a shared DLL
#else
   Enable3dControlsStatic();   // Call this when linking to MFC statically
#endif
#endif

   try
   {
      CSecurityDescriptorAllowAll sd;

      CSecurityAttributes sa(sd);

      const wstring wideCommandLine = GetCommandLineW();

      int numArgs = 0;

      CSmartLocalPointer spArgv(::CommandLineToArgvW(wideCommandLine.c_str(), &numArgs));

      bool hasRun = false;

      if (spArgv.IsValid() && numArgs == 2 || numArgs == 3)
      {
         const wchar_t * const *ppArgv = reinterpret_cast<const wchar_t **>(spArgv.Get());

         const _tstring eventNamePrefix = (numArgs == 3 ? CStringConverter::WtoT(ppArgv[2]) : _T("JetByteTools"));

         if (0 == wcscmp(ppArgv[1], L"STOP"))
         {
            hasRun = true;

            CManualResetEvent shutdownEvent(CGlobalName(eventNamePrefix + _T("ServerShutdown")), &sa);

            shutdownEvent.Set();

            //::Sleep(10000);

            //shutdownEvent.Reset();
         }
         else if (0 == wcscmp(ppArgv[1], L"WAIT_FOR_START"))
         {
            hasRun = true;

            CManualResetEvent serverStartedEvent(CGlobalName(eventNamePrefix + _T("ServerStarted")), &sa);

            if (!serverStartedEvent.Wait(10000))
            {
               exit(1);
            }
         }
         else if (0 == wcscmp(ppArgv[1], L"WAIT_FOR_STOP"))
         {
            hasRun = true;

            CManualResetEvent shutdownEvent(CGlobalName(eventNamePrefix + _T("ServerShutdown")), &sa);
            CManualResetEvent serverStoppedEvent(CGlobalName(eventNamePrefix + _T("ServerStopped")), &sa);

            shutdownEvent.Set();

            if (!serverStoppedEvent.Wait(10000))
            {
               exit(1);
            }
         }
         else if (0 == wcscmp(ppArgv[1], L"RUN"))
         {
            CServerShutdownDlg dlg(eventNamePrefix);

            m_pMainWnd = &dlg;

            dlg.DoModal();

         }
      }

      if (!hasRun)
      {
         CServerShutdownDlg dlg(_T("JetByteTools"));

         m_pMainWnd = &dlg;

         dlg.DoModal();
      }
   }
   catch(JetByteTools::Core::CException &e)
   {
      e.MessageBox();
   }
   catch(...)
   {
      ::MessageBox(0, _T("Unexpected exception"), _T("ServerShutdown"), MB_ICONWARNING | MB_OK);
   }

   // Since the dialog has been closed, return FALSE so that we exit the
   //  application, rather than start the application's message pump.
   return FALSE;
}
